;;; @(#) Kinem
;;; $B2OF;(B kinematic wave $B%b%G%k(B
;;; $Lastupdate: Thu Jan  4 18:50:26 2001 $

------------------------------------------------------------------------
* $B35MW(B

$B$3$N%G%#%l%/%H%j$K$O!"(Bkinem.h,cc $B$H$=$NMxMQNc$rCV$$$F$$$^$9!#(Bohymos-2.0
$B0J9_$KBP1~$7$F$$$^$9!#(B

 o kinem.h : class Kinem $B$rDj5A$7$F$$$^$9!#(B
 o kinem.cc : class Kinem $B$r<BAu$7$F$$$^$9!#(B

class Kinem $B$O!"(Bohymos $B$N(B class Element $B$r7Q>5$7$?2OF;(B kinematic wave 
$B%b%G%k$G$9!#N.$l$NDq93B'$H$7$F(B Manning $B<0$rMQ$$$F$$$^$9!#(B

$B6qBNE*$K1?F0J}Dx<0$r<($7$^$9!#(B

  Q : $BN.NL(B (m3/s)
  A : $BDL?eCGLL@Q(B (m2)
  R : $B7B?<(B (m2)
  K : 
  Z : R = K * pow(A, Z) $B$H$7$?$H$-$NDj?t(B
  n : $B%^%K%s%0$NAFEY78?t(B (m-s)
  i : $B8{G[(B (-)
  m : $BN.NL(B-$B?e?<4X78<0$NDL?eCGLL@Q$K$+$+$k;X?t(B (-) $B$G!"(BManning $B$NDq93B'$r(B
      $BMQ$$$k$3$H$K$9$l$P!"(Bm = 2/3*Z + 1 $B$HI=$5$l$k!#(B
  alpha : pow(K, 2/3)*\sqrt(i)/n $B$G7W;;$5$l$kDj?t(B (m-s)

$B0J>e$N5-9f$rMQ$$$F1?F0J}Dx<0$O!"(B

  Q = alpha * pow(A, m)

$B$H=q$1$^$9!#(B

$B$3$N<0$HO"B3<0$+$i9=@.$5$l$kJPHyJ,J}Dx<0$r!"(BBeven $B$N%9%-!<%`(B
(Beven, 1979) $B$G2r$$$F$$$^$9!#(B

------------------------------------------------------------------------
* $B%/%i%9L>(B

  Kinem

------------------------------------------------------------------------
* $B<u?.C<;R$N;EMM(B

$B<u?.C<;R$OFs<oN`$"$j$^$9!#0l$D$O2OF;>eC<$+$i$NN.F~NL$r<u$1<h$kC<;R!"$b$&(B
$B0l$D$OB&J}N.F~NL$r<u$1<h$kC<;R$G$9!#$=$l$>$l$N8D?t$O2DJQ$G!"(BKinem $B$N%3%s(B
$B%9%H%i%/%?$G;XDj$9$k$3$H$,$G$-$^$9!#$$$:$l$b(B Receive<double> $B7?$G!"2OF;(B
$B>eC<$NC<;R$N%*%V%8%'%/%HL>$O(B rpu, $BB&J}N.F~NL$NC<;R$N%*%V%8%'%/%HL>$O(B rpl 
$B$G$9!#%*%V%8%'%/%HHV9f$O$=$l$>$l(B 0 $B!A(B n-1 (n $B$OC<;R$N8D?t(B) $B$H$J$j$^$9!#(B
$B$^$?$$$:$l$NN.NL$bC10L$O(B m3/s $B$G$9!#(B

------------------------------------------------------------------------
* $BAw?.C<;R$N;EMM(B

$BAw?.C<;R$O0l$D$G$9!#(B

Send<double> $B7?(B, $B%*%V%8%'%/%HL>(B sp, $B%*%V%8%'%/%HHV9f(B 0 $B$NAw?.C<;R(B
$B$+$i!"2OF;2<C<$+$i$NN.=PNL(B (m3/s) $B$rAw?.$7$^$9!#(B

------------------------------------------------------------------------
* $BF~NO%U%!%$%k(B

 o ohymos $B%Q%i%a%?%U%!%$%k(B
 o ohymos $B=i4|>uBVNL%U%!%$%k(B

$B$NFs$D$NF~NO%U%!%$%k$,I,MW$G$9!#0J2<$=$l$>$l$K$D$$$F@bL@$7$^$9!#(B

------------------------------------------------------------------------
** ohymos $B%Q%i%a%?%U%!%$%k(B

Kinem::Set_parameter(FILE* fp) $B$GFI$_9~$^$l$k%U%!%$%k$G$9!#(B
Set_parameter(FILE* fp) $B$O0J2<$N$h$&$K$7$F%G!<%?$rFI$_9~$_$^$9!#(B

	fscanf(fp, "%lf %lf %lf %lf %d %ld %lf", 
			   &mL, &mB, &mG, &mMan, &mDiv, &mDt, &mTheta)

	for (int i = 0; i <= mDiv; i++)	fscanf(fp, "%lf", &mK[i]);
	for (int i = 0; i <= mDiv; i++)	fscanf(fp, "%lf", &mZ[i]);

mL : $B2OF;D9(B (m)
mB : $B2OF;I}(B (m)
mG : $B2OF;8{G[(B (-)
mMan : Manning $B$NAFEY78?t(B (m-s)
mDiv : $B6u4V:9J,J,3d?t(B (-)
mDt : $B7W;;;~4V4V3V(B (s)
mTheta : $B:9J,7W;;$GMQ$$$k=E$_78?t(B (0.5 $B!A(B 1.0, 0.65 $B$,I8=`E*$JCM(B)
mK[i] : $B3F7W;;CGLL$K$*$1$k(B K (R = K * pow(A, Z) $B$N(B K) $B$NCM(B
mZ[i] : $B3F7W;;CGLL$K$*$1$k(B Z (R = K * pow(A, Z) $B$N(B Z) $B$NCM(B

mK $B$H(B mZ $B$K$D$$$F$O!"$=$l$>$l(B mDiv+1 $B8D$N%G!<%?$rM?$($F2<$5$$!#(B

$BG[I[FbMF$N(B tkinem.pmt, tkinemscf.pmt $B$,$3$N%G!<%?$G$9!#(B

------------------------------------------------------------------------
** ohymos $B=i4|>uBVNL%U%!%$%k(B

Kinem::Set_initial_state(FILE* fp) $B$GFI$_9~$^$l$k%U%!%$%k$G$9!#(B
Set_initial_state(FILE* fp) $B$O0J2<$N$h$&$K$7$F%G!<%?$rFI$_9~$_$^$9!#(B

	fscanf(fp, "%ld", &current_time)

current_time : $B7W;;3+;O;~9o(B (s)

$B=i4|>uBVNL%U%!%$%k$+$iFI$_9~$`%G!<%?$O7W;;3+;O;~9o$N$_$G$9!#7W;;3+;O;~$N(B
$B2OF;N.NL$dB&J}N.F~NL$O!"<u?.C<;R$+$i(B($B$9$J$o$AB>$N%b%G%k$dF~NO%U%!%$%k$+$i(B)
$B<hF@$7$^$9!#(B

$BG[I[FbMF$N(B tkinem.ist, tkinemscf.ist $B$,$3$N%G!<%?$G$9!#(B

------------------------------------------------------------------------
* $B=PNO(B

$B!&2OF;2<C<$+$i$NN.=PNL(B (m3/s)

$B$N;~7ONs$r=PNO$7$^$9!#(B

------------------------------------------------------------------------
* $B%3%s%Q%$%k(B

% make

$B$H$9$k$H!"(Btkinem $B$H(B ohymos $B$H$$$&<B9T7A<0%U%!%$%k$,:n@.$5$l$^$9!#(Btkinem 
$B$O!"(Bohymos 2.0 $B0J9_$GMxMQ$G$-$k<B9T7A<0%U%!%$%k!"(Bohymos $B$O(B ohymos 3.0 
$B0J9_$GMxMQ$G$-$k<B9T7A<0%U%!%$%k$G$9!#<B9T7A<0%U%!%$%k(B ohymos $B$O!"(Bohymos
3.0 $B$G%5%]!<%H$5$l$?(B SCF ($B9=B$Dj5A%U%!%$%k(B) $BJ}<0$KBP1~$7$?$b$N$G$9!#(B

tkinem $B$G$O!"(Btkinem.* $B$N0lO"$N%U%!%$%k$r!"(Bohymos $B$G$O!"(Btkinemscf.* $B$N(B
$B0lO"$N%U%!%$%k$r;HMQ$7$^$9!#(B

------------------------------------------------------------------------
* $B;29MJ88%(B

Beven, K (1979) :
On the Generalized Kinematic Routing Method, 
Water Resources Research, VOL. 15, NO. 5, pp. 1238--1242.

;;; Local Variables: ***
;;; mode: Outline ***
;;; indent-tabs-mode: nil ***
;;; tab-width: 8 ***
;;; End: ***
